<template>
  <div class="with-borders main-holder" @scroll="handleScroll">
    <HeaderTemplate :change-glasses-type="changeGlassesType" />

    <FiltersTemplate
      :fetch-glasses="fetchGlasses"
      :is-loading="isLoading"
      :active-filters="activeFilters"
      :add-filter="addFilter"
      :remove-filter="removeFilter"
      :clear-filters="clearFilters"
      :total-count="totalCount"
      :glasses-type="glassesType"
    />
    <GlassesTemplate :glasses-array="glassesData.glasses" v-if="glassesData.glasses" />
    <div class="loading-animation" :class="{ 'is-loading': isLoading }">LOADING...</div>
  </div>
</template>
<script lang="ts">
import { getGlassesAPI } from '@/api/getGlassesAPI'
import { type IGlassesData, GLASSES_TYPES, type ActiveFilter } from '@/types/glasses'
import HeaderTemplate from '@/components/HeaderTemplate.vue'
import FiltersTemplate from '@/components/Filters/FiltersTemplate.vue'
import GlassesTemplate from '@/components/Glasses/GlassesTemplate.vue'
import { constructQueryParams } from '@/helpers/constructQueryParams'

const initialState = {
  glasses: [],
  meta: {
    total_count: 1
  }
}

export default {
  components: {
    HeaderTemplate,
    FiltersTemplate,
    GlassesTemplate
  },
  data() {
    return {
      isLoading: false,
      glassesData: initialState as IGlassesData,
      isError: false,
      activeFilters: [] as ActiveFilter[],
      glassesType: GLASSES_TYPES.SPECT_FOR_WOMEN
    }
  },
  computed: {
    totalCount() {
      return this.glassesData.meta.total_count || 0
    }
  },
  methods: {
    async fetchGlasses(
      queryParams = '',
      glassesType = GLASSES_TYPES.SPECT_FOR_WOMEN,
      pageNumber = 1
    ) {
      this.isLoading = true
      try {
        this.glassesData = await getGlassesAPI(queryParams, glassesType, pageNumber)
      } catch (error) {
        this.isError = true
        console.error(error)
      }
      this.isLoading = false
    },

    async handleScroll() {
      const height = Math.max(
        document.body.scrollHeight,
        document.body.clientHeight,
        document.body.offsetHeight,
        document.documentElement.scrollHeight,
        document.documentElement.offsetHeight,
        document.documentElement.clientHeight
      )

      const bottomOfWindow = document.documentElement.scrollTop + window.innerHeight >= height - 20
      const pageNumber = this.glassesData.glasses.length / 12 + 1
      if (
        bottomOfWindow &&
        pageNumber < this.glassesData.meta.total_count / 12 &&
        !this.isLoading
      ) {
        const queryParams = constructQueryParams(this.activeFilters)
        this.isLoading = true
        try {
          const newGlassesData = await getGlassesAPI(queryParams, this.glassesType, pageNumber)
          this.glassesData.glasses.push(...newGlassesData.glasses)
        } catch (error) {
          this.isError = true
          console.error(error)
        }
        this.isLoading = false
      }
    },
    addFilter(filter: ActiveFilter) {
      if (!this.activeFilters.find((element) => element.name === filter.name)) {
        this.activeFilters = [...this.activeFilters, filter]
        const queryParams = constructQueryParams(this.activeFilters)
        this.fetchGlasses(queryParams, this.glassesType)
      } else {
        this.removeFilter(filter)
      }
    },
    removeFilter(filter: ActiveFilter) {
      this.activeFilters = this.activeFilters.filter((element) => element.name !== filter.name)
      const queryParams = constructQueryParams(this.activeFilters)
      this.fetchGlasses(queryParams, this.glassesType)
    },
    clearFilters() {
      this.activeFilters = []
      this.fetchGlasses('', this.glassesType)
    },
    changeGlassesType(glasses: GLASSES_TYPES) {
      this.glassesData = initialState
      this.glassesType = glasses
      this.fetchGlasses('', glasses)
      this.activeFilters = []
    }
  },
  created() {
    this.fetchGlasses()
  },
  mounted() {
    window.addEventListener('scroll', this.handleScroll)
  },

  beforeUnmount() {
    window.removeEventListener('scroll', this.handleScroll)
  }
}
</script>
<style>
@import './GlassesView.css';
</style>
